%define name	qemu
%define version	0.7.1
%define release	%mkrel 3
#define cvsdate	20050708
%define qvmdate	20050801
%define targets	i386-user arm-user armeb-user sparc-user ppc-user i386-softmmu ppc-softmmu sparc-softmmu x86_64-softmmu mips-softmmu

%define __find_requires %{_builddir}/%{name}-%{version}/find_requires.sh

# QEMU doesn't build on x86 with gcc4 at this time
%if %{mdkversion} >= 200600
%ifarch %{ix86}
%define __cc	gcc-$(gcc3.3-version)
BuildRequires:	gcc3.3
%endif
%endif

Summary:	QEMU CPU Emulator
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	%{name}-%{version}%{?cvsdate:-%{cvsdate}}.tar.bz2
Source1:	qvm86-%{qvmdate}.tar.bz2
Source2:	kqemu.h
Patch1:		qemu-0.7.1-DESTDIR.patch.bz2
Patch2:		qemu-0.7.1-qvm86.patch.bz2
Patch3:		qemu-0.7.1-loader.patch.bz2
Patch4:		qemu-0.7.0-cross64-mingw32-fixes.patch.bz2
Patch5:		qemu-0.7.0-sheep-net.patch.bz2
Patch6:		qemu-0.7.0-gcc4.patch.bz2
Patch7:		qemu-0.7.0-gcc4-dot-syms.patch.bz2
Patch8:		qemu-0.7.1-qvm86-colateral.patch.bz2
Patch9:		qemu-0.7.0-x86_64-direct-jump.patch.bz2
Patch10:	qemu-0.7.0-x86_64-softmmu-asm.patch.bz2
Patch11:	qemu-0.7.0-pcnet.patch6.bz2
Patch12:	qemu-0.7.1-x86_64-enable-kqemu.patch.bz2
Patch13:	qemu-0.7.1-ide-fix.patch.bz2
License:	GPL
URL:		http://fabrice.bellard.free.fr/qemu/
Group:		Emulators
BuildRequires:	libSDL-devel, tetex-texi2html
ExclusiveArch:	%{ix86} ppc x86_64 amd64 sparc
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
QEMU is a FAST! processor emulator. By using dynamic translation it
achieves a reasonnable speed while being easy to port on new host
CPUs. QEMU has two operating modes:

* User mode emulation. In this mode, QEMU can launch Linux processes
  compiled for one CPU on another CPU. Linux system calls are
  converted because of endianness and 32/64 bit mismatches. Wine
  (Windows emulation) and DOSEMU (DOS emulation) are the main targets
  for QEMU.

* Full system emulation. In this mode, QEMU emulates a full system,
  including a processor and various peripherials. Currently, it is
  only used to launch an x86 Linux kernel on an x86 Linux system. It
  enables easier testing and debugging of system code. It can also be
  used to provide virtual hosting of several virtual PC on a single
  server.

%ifarch %{ix86}
%define	module_name qvm86	
%define module_version 0.0.0.%{qvmdate}
%package -n dkms-%{module_name}
License:	GPL
Summary:	DKMS-ready kernel-source for QEmu x86 virtualization module
Url:		https://savannah.nongnu.org/projects/qvm86/
Group:		Emulators
Requires:	qemu
Requires(pre):	dkms
Requires(post): dkms

%description -n dkms-%{module_name}
qvm86 is a kernel module to provide x86 virtualisation capabilities for the
qemu emulator. Virtualisation allows "emulated" code to be run natively on
the host cpu, using the CPU protection mechanisms to intercept and emulate
priveleged events.
%endif

%prep
%setup -q -a1
%patch1 -p1 -b .DESTDIR
%patch2 -p0 -b .qvm86
%patch3 -p1 -b .loader
%patch4 -p1 -b .cross64-mingw32-fixes
%patch5 -p1 -b .sheep-net
%patch6 -p1 -b .gcc4
%patch7 -p1 -b .gcc4-dot-syms
%patch8 -p1 -b .qvm86-colateral
%patch9 -p1 -b .x86_64-direct-jump
%patch10 -p1 -b .x86_64-softmmu-asm
%patch11 -p1 -b .pcnet
%patch12 -p1 -b .x86_64-enable-kqemu
%patch13 -p1 -b .ide-fix

mv -f qvm86/Makefile qvm86/Makefile.sav
echo "clean:" > qvm86/Makefile
echo "#!/bin/true" > qvm86/install.sh
cat %{SOURCE2} > qvm86/kqemu.h

%build
./configure --prefix=%{_prefix} --cc=%{__cc} --target-list="%{targets}"
%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

# nuke explicit dependencies on GLIBC_PRIVATE
cat >find_requires.sh << EOF
#!/bin/sh
%{_prefix}/lib/rpm/find-requires %{buildroot} %{_target_cpu} | grep -v GLIBC_PRIVATE
EOF
chmod +x find_requires.sh

# remove unpackaged files
rm -rf $RPM_BUILD_ROOT%{_docdir}/qemu

#qvm86
%ifarch %{ix86}
mkdir -p %{buildroot}/usr/src/%{module_name}-%{module_version}
cp -a qvm86/* %{buildroot}/usr/src/%{module_name}-%{module_version}
mv -f %{buildroot}/usr/src/%{module_name}-%{module_version}/Makefile.sav %{buildroot}/usr/src/%{module_name}-%{module_version}/Makefile
cat > %{buildroot}/usr/src/%{module_name}-%{module_version}/dkms.conf <<EOF

PACKAGE_VERSION="%{module_version}"

# Items below here should not have to change with each driver version
PACKAGE_NAME="%{module_name}"
MAKE[0]="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build ; make KERNEL_PATH=\${kernel_source_dir}"
CLEAN="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build ; make KERNEL_PATH=\${kernel_source_dir} clean"

BUILT_MODULE_NAME[0]="\$PACKAGE_NAME"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{module_name}/"

REMAKE_INITRD="no"
AUTOINSTALL=yes

EOF

mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d/
cat > %{buildroot}%{_sysconfdir}/udev/rules.d/qvm86.rules <<EOF
KERNEL="%{module_name}", MODE="0666"
EOF

%post -n dkms-%{module_name}
dkms add -m %{module_name} -v %{module_version} --rpm_safe_upgrade
dkms build -m %{module_name} -v %{module_version} --rpm_safe_upgrade
dkms install -m %{module_name} -v %{module_version} --rpm_safe_upgrade
grep '[^#]*%{module_name}' %{_sysconfdir}/modprobe.preload || echo %{module_name}>>%{_sysconfdir}/modprobe.preload
#Load it now so that we don't need to wait until next reboot (except if we already had one loaded...)
modprobe %{module_name}

%preun -n dkms-%{module_name}
sed -i '/.*%{module_name}.*/d' /etc/modprobe.preload
dkms remove -m %{module_name} -v %{module_version} --rpm_safe_upgrade --all ||:

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README qemu-doc.html qemu-tech.html
%{_bindir}/qemu
%{_bindir}/qemu-arm
%{_bindir}/qemu-armeb
%{_bindir}/qemu-i386
%{_bindir}/qemu-ppc
%{_bindir}/qemu-sparc
%{_bindir}/qemu-system-ppc
%{_bindir}/qemu-system-mips
%{_bindir}/qemu-system-sparc
%{_bindir}/qemu-system-x86_64
%{_bindir}/qemu-img
%{_mandir}/man1/qemu.1*
%{_mandir}/man1/qemu-img.1*
%dir %{_datadir}/qemu
%{_datadir}/qemu/*.bin
%{_datadir}/qemu/*.elf
%{_datadir}/qemu/keymaps
%{_datadir}/qemu/video.x

%ifarch %{ix86}
%files -n dkms-%{module_name}
%_prefix/src/%{module_name}-%{module_version}
%config(noreplace) %{_sysconfdir}/udev/rules.d/qvm86.rules
%endif

%changelog
* Thu Aug 11 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.1-3mdk
- IDE fix from CVS for FreeBSD/AMD64 support
- run-time detect qvm86/kqemu and enable specific features accordingly
- qvm86 updates from CVS (2005/08/01):
  * performance improvements
  * add support for pae enabled host kernels

* Mon Jul 25 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.1-2mdk
- use new kqemu.h from kqemu 
- enable kqemu support on x86_64 (P12)
- don't break x86_64 in P8 when kqemu is enabled 

* Mon Jul 25 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.1-1mdk
- only use gcc3.3 in 2006+ and x86
- load initrd at a higher address in pc emulation
- 0.7.1:
  * fixes to sparc64 and ppc system emulation
  * add initial support for mips system emulation
  * fixes to i386 emulation: fscale, add overflow exceptions in divisions
  * fix 64-bit virtual addressing
  * allow more than 4 GB of physical memory
  * add IO-APIC support for Windows 64
  * add support for s390 hosts
  * linux-user improvements: more set/getsockopt values, [f]truncate64,

* Thu Jul 21 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-8mdk
- add AMD pcnet patch (faster NIC, add -nic-pcnet to use it)
- fix qvm86 description (only runs on kernels without PAE)
- enforce using gcc3.3

* Sat Jun  4 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.0-7mdk
- minor optimizations to x86-64 host:
  * support direct jumps
  * assembly optimizations to softmmu mode

* Thu Jun  2 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.0-6mdk
- fix build with gcc4 (Paul Brook)
- fix build with gcc4 on x86_64 and local dot symbols
- fix x86-64 system emulation regression introduced from qvm86 patch

* Wed Jun  1 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.7.0-5mdk
- refactor buildrequires
- add support for -sheep-net network emulation

* Tue May 17 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.7.0-4mdk
- remove double free in slirp code
- 64-bit fixes to -user-net
- cross-compilation fixes to mingw32 from 64-bit host
- selected fixes from CVS (2005/05/17):
  * Windows 2000 install disk full hack (with -win2k-hack)
  * BMDMA interrupt fix (aka Solaris x86 IDE bug fix)
  * ne2000 reset fix (aka OS/2 Warp V4 fix)
  * handle the case where several PCI irqs share the same PIC irq
  * open fix in Linux/ARM user emulation
  * ARM saturating arithmetic fixes
  * ARM VFP dump fix
  * PPC dcbz fix

* Fri May 13 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-3mdk
- Support qvm86 instead

* Wed May 11 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-2mdk
- Enable kqemu support

* Fri Apr 29 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-1mdk
- 0.7.0
- regenerate P1
- add new targets

* Sun Nov 14 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.6.1-1mdk
- 0.6.1
- build sparc target
- add initial sparc host cpu support
- drop P0, P2 & P3 (merged upstream)
- regenerate P1

* Wed Sep 29 2004 Michael Scherer <misc@mandrake.org> 0.6.0-2mdk 
- fix memleak of userspace-net-stack, ( http://lists.gnu.org/archive/html/qemu-devel/2004-09/msg00244.html )

* Mon Sep  6 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.6.0-1mdk
- 0.6.0
- updates from CVS (2004/09/06):
  * fix x86 bound instruction
  * fix build on x86 with asm memory helpers
  * fix build on ppc

* Tue Mar 02 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.5.0-4mdk
- buildrequires

* Fri Nov  7 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-3mdk
- lib64 fixes
- update to current CVS:
  - float access fixes when using soft mmu
  - PC emulation support on PowerPC
  - A20 support

* Thu Nov  6 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-2mdk
- add initial AMD64 host cpu support

* Thu Nov  6 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-1mdk
- 0.5.0

* Fri Aug 01 2003 Michael Scherer <scherer.michael@free.fr> 0.4.1-2mdk
- BuildRequires ( glibc-static-devel ) 

* Mon Jul  7 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.1-1mdk
- 0.4.1

* Tue Jun  3 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.2-1mdk
- 0.2

* Sat Apr 12 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.6-1mdk
- 0.1.6

* Mon Mar 31 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.4-1mdk
- 0.1.4

* Thu Mar 27 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.2-1mdk
- First Mandrake Linux package
- Patch0: Fix x86 signal handler to retrieve pc from [REG_IP] slot
- Patch1: Add support for nanosecond resolution timestamps from glibc 2.3
- Patch2: Adjust ldscripts for glibc >= 2.3
- Patch3: Handle exit_group syscall as an exit
- Patch4: Add missing includes
